--- pynicotine/gtkgui/__init__.py	2024-10-16 00:20:31.000000000 +0800
+++ pynicotine/gtkgui/__init__.py	2024-10-30 17:21:50.000000000 +0800
@@ -134,8 +134,10 @@
         os.environ["GSK_RENDERER"] = "cairo"
 
     elif sys.platform == "darwin":
-        # Older GL renderer is still faster on macOS for now
-        os.environ["GSK_RENDERER"] = "gl"
+        # Use Cairo software rendering due to flickering issues in the GPU renderer (#2859).
+        # https://gitlab.gnome.org/GNOME/gtk/-/issues/5858
+        # https://github.com/nicotine-plus/nicotine-plus/issues/2942
+        os.environ["GSK_RENDERER"] = "cairo"
 
     error = check_gtk_version(gtk_api_version=os.environ.get("NICOTINE_GTK_VERSION", get_default_gtk_version()))
 
